//----------------------------------------------
// StyleComboBox.cs (c) 2005 by Charles Petzold
//----------------------------------------------
using System;
using System.Drawing;
using System.Windows.Forms;

class StyleComboBox : ComboBox
{
    public string FamilyName
    {
        set
        {
            TryStyle(value, FontStyle.Regular, "Standard");
            TryStyle(value, FontStyle.Italic, "Kursiv");
            TryStyle(value, FontStyle.Bold, "Fett");
            TryStyle(value, FontStyle.Bold | FontStyle.Italic, "Fett Kursiv");
            SelectedIndex = 0;
        }
    }
    public FontStyle FontStyle
    {
        set
        {
            if ((value & FontStyle.Bold & FontStyle.Italic) != 0)
                SelectedItem = "Fett Kursiv";

            else if ((value & FontStyle.Bold) != 0)
                SelectedItem = "Fett";

            else if ((value & FontStyle.Italic) != 0)
                SelectedItem = "Kursiv";
            else
                SelectedItem = "Standard";
        }
        get
        {
            if (SelectedItem.ToString() == "Fett Kursiv")
                return FontStyle.Bold | FontStyle.Italic;

            else if (SelectedItem.ToString() == "Fett")
                return FontStyle.Bold;

            else if (SelectedItem.ToString() == "Kursiv")
                return FontStyle.Italic;

            return FontStyle.Regular;
        }
    }
    void TryStyle(string strFamilyName, FontStyle fntstyle, string strStyle)
    {
        int index = FindStringExact(strStyle);

        try
        {
            new Font(strFamilyName, 12, fntstyle);

            if (index == -1)
                Items.Add(strStyle);
        }
        catch
        {
            if (index != -1)
                Items.Remove(strStyle);
        }
    }
}