//-------------------------------------------
// SimpleMenu.cs (c) 2005 by Charles Petzold
//-------------------------------------------
using System;
using System.Drawing;
using System.Windows.Forms;

class SimpleMenu: Form
{
    [STAThread]
    public static void Main()
    {
        Application.EnableVisualStyles();
        Application.Run(new SimpleMenu());
    }
    public SimpleMenu()
    {
        Text = "Einfaches Men";

        // Hauptmen.
        MenuStrip menu = new MenuStrip();
        menu.Parent = this;

        // Element Datei.
        ToolStripMenuItem itemFile = new ToolStripMenuItem();
        itemFile.Text = "&Datei";
        menu.Items.Add(itemFile);

        // Element ffnen.
        ToolStripMenuItem itemOpen = new ToolStripMenuItem();
        itemOpen.Text = "&ffnen...";
        itemOpen.ShortcutKeys = Keys.Control | Keys.F;
        itemOpen.Click += OpenOnClick;
        itemFile.DropDownItems.Add(itemOpen);

        // Trennlinie.
        ToolStripSeparator itemSep = new ToolStripSeparator();
        itemFile.DropDownItems.Add(itemSep);

        // Element Beenden.
        ToolStripMenuItem itemExit = new ToolStripMenuItem();
        itemExit.Text = "&Beenden";
        itemExit.Click += ExitOnClick;
        itemFile.DropDownItems.Add(itemExit);

        // Element Hilfe.
        ToolStripMenuItem itemHelp = new ToolStripMenuItem();
        itemHelp.Text = "&Hilfe";
        menu.Items.Add(itemHelp);

        // Element Info.
        ToolStripMenuItem itemAbout = new ToolStripMenuItem();
        itemAbout.Text = "&Info...";
        itemAbout.Click += AboutOnClick;
        itemHelp.DropDownItems.Add(itemAbout);
    }
    void OpenOnClick(object objSrc, EventArgs args)
    {
        MessageBox.Show("Funktion \"ffnen\" noch nicht implementiert", Text);
    }
    void ExitOnClick(object objSrc, EventArgs args)
    {
        Close();
    }
    void AboutOnClick(object objSrc, EventArgs args)
    {
        MessageBox.Show("(c) 2005 by Charles Petzold", Text);
    }
}
