//-------------------------------------------------------------------------
// CalendarCell.cs, aus dem MSDN-Artikel 
//              "How to: Host Controls in Windows Forms DataGridView Cells
//-------------------------------------------------------------------------
using System;
using System.Windows.Forms;

public class CalendarCell : DataGridViewTextBoxCell
{

    public CalendarCell()
        : base()
    {
        // Kurzes Datumsformat verwenden.
        this.Style.Format = "d";
    }

    public override void InitializeEditingControl(int rowIndex, object
        initialFormattedValue, DataGridViewCellStyle dataGridViewCellStyle)
    {
        // Den aktuellen Zellenwert in das Editiersteuerelement eintragen.
        base.InitializeEditingControl(rowIndex, initialFormattedValue,
            dataGridViewCellStyle);
        CalendarEditingControl ctl =
            DataGridView.EditingControl as CalendarEditingControl;
        ctl.Value = (DateTime)this.Value;
    }

    public override Type EditType
    {
        get
        {
            // Typ des Editiersteuerelements zurckgeben, das CalendarCell benutzt.
            return typeof(CalendarEditingControl);
        }
    }

    public override Type ValueType
    {
        get
        {
            // Typ des Werts zurckgeben, den die CalendarCell enthlt.
            return typeof(DateTime);
        }
    }

    public override object DefaultNewRowValue
    {
        get
        {
            // Aktuelles Datum und Uhrzeit als Standardwert benutzen.
            return DateTime.Now;
        }
    }
}
