//---------------------------------------------------------
// MdiBrowser.FavoritesMenu.cs (c) 2005 by Charles Petzold
// Aus dem Programm MdiBrowser
//---------------------------------------------------------
using System;
using System.Drawing;
using System.Windows.Forms;

partial class MdiBrowser : Form
{
    ToolStripMenuItem itemAdd, itemSetHome;

    ToolStripMenuItem FavoritesMenu()
    {
        ToolStripMenuItem itemFavorites = new ToolStripMenuItem("Fa&voriten");
        itemFavorites.DropDownOpening += FavoritesOnDropDownOpening;

        return itemFavorites;
    }
    void FavoritesOnDropDownOpening(object objSrc, EventArgs args)
    {
        ToolStripMenuItem itemFavorites = objSrc as ToolStripMenuItem;
        BrowserChild bc = ActiveMdiChild as BrowserChild;

        // Alle Eintrge aus dem Dropdownmen lschen.
        itemFavorites.DropDownItems.Clear();

        itemAdd = new ToolStripMenuItem("&Zu Favoriten hinzufgen");
        itemAdd.Enabled = (bc != null);
        itemAdd.Click += AddOnClick;
        itemFavorites.DropDownItems.Add(itemAdd);

        itemSetHome = new ToolStripMenuItem("&Als Startseite festlegen");
        itemSetHome.Enabled = (bc != null);
        itemSetHome.Click += SetHomeOnClick;
        itemFavorites.DropDownItems.Add(itemSetHome);

        itemFavorites.DropDownItems.Add(new ToolStripSeparator());

        // Favoriten zum Men hinzufgen;
        foreach (Favorite fav in settings.Favorites)
        {
            ToolStripMenuItem item = new ToolStripMenuItem();
            item.Text = fav.Title;
            item.Tag = fav.Url;
            item.Click += FavoriteOnClick;
            itemFavorites.DropDownItems.Add(item);
        }
    }
    void AddOnClick(object objSrc, EventArgs args)
    {
        BrowserChild bc = ActiveMdiChild as BrowserChild;

        if (bc != null)
        {
            Favorite fav = new Favorite(bc.WebBrowser.DocumentTitle,
                                        bc.WebBrowser.Url.ToString());
            settings.Favorites.Add(fav);
            settings.Favorites.Sort();
            settings.Save(strAppData);
        }
    }
    void SetHomeOnClick(object objSrc, EventArgs args)
    {
        BrowserChild bc = ActiveMdiChild as BrowserChild;

        if (bc != null)
        {
            settings.Home = bc.WebBrowser.Url.ToString();
        }
    }
    void FavoriteOnClick(object objSrc, EventArgs args)
    {
        ToolStripMenuItem item = objSrc as ToolStripMenuItem;
        Go((string)item.Tag, false);
    }
}
