//------------------------------------------------------
// MdiBrowser.WindowMenu.cs (c) 2005 by Charles Petzold
// Aus dem Programm MdiBrowser
//------------------------------------------------------
using System;
using System.Drawing;
using System.Windows.Forms;

partial class MdiBrowser : Form
{
    ToolStripMenuItem WindowMenu()
    {
        ToolStripMenuItem itemWindow = new ToolStripMenuItem("&Fenster");
        menu.MdiWindowListItem = itemWindow;

        ToolStripMenuItem item = new ToolStripMenuItem("&berlappend");
        item.Tag = MdiLayout.Cascade;
        item.Click += WindowArrangeOnClick;
        itemWindow.DropDownItems.Add(item);

        item = new ToolStripMenuItem("&Horizontal anordnen");
        item.Tag = MdiLayout.TileHorizontal;
        item.Click += WindowArrangeOnClick;
        itemWindow.DropDownItems.Add(item);

        item = new ToolStripMenuItem("&Vertikal anordnen");
        item.Tag = MdiLayout.TileVertical;
        item.Click += WindowArrangeOnClick;
        itemWindow.DropDownItems.Add(item);

        item = new ToolStripMenuItem("&Symbole anordnen");
        item.Tag = MdiLayout.ArrangeIcons;
        item.Click += WindowArrangeOnClick;
        itemWindow.DropDownItems.Add(item);

        itemWindow.DropDownItems.Add(new ToolStripSeparator());

        item = new ToolStripMenuItem("&Alle Fenster schlieen");
        item.Click += CloseAllOnClick;
        itemWindow.DropDownItems.Add(item);

        itemWindow.DropDownItems.Add(new ToolStripSeparator());

        return itemWindow;
    }
    // Zwei kleine Click-Handler.
    void WindowArrangeOnClick(object objSrc, EventArgs args)
    {
        ToolStripMenuItem item = objSrc as ToolStripMenuItem;
        LayoutMdi((MdiLayout)item.Tag);
    }
    void CloseAllOnClick(object objSrc, EventArgs args)
    {
        while (MdiChildren.Length > 0)
            MdiChildren[0].Close();
    }
}
